//@line 37 "/home/ondrejd/mozilla/extensions/xpcomviewer/resources/content/notedialog.js"

var gTitleTextbox   = null;
var gTextTextbox    = null;
var gType           = "note";
var gAction         = "add";
var gTargetName     = "";
var gEditedItem     = null;


////////////////////////////////////////////////////////////////////////////////
// Taken from global.js (because we need only this from all global.js file)
/**
 * Returns current timestamp (I'm using it fore timestamp field in databases, 
 * returned format is this: 8/28/2006 1:47:17 PM
 * @return  string
 */
Date.prototype.getCurrentTimestamp = function() {
  return this.getUTCMonth() + "/" + this.getUTCDate() + "/" + 
  		this.getUTCFullYear() + " " + this.toLocaleTimeString();
};
////////////////////////////////////////////////////////////////////////////////



/**
 * Dialog JavaScript object
 */
var gNoteDialog =
{

  /**
   * On dialog load.
   */
  onLoad : function(aEvent)
  {
    gTitleTextbox = document.getElementById ("title-textbox");
    gTextTextbox = document.getElementById ("text-textbox");
		
		if("arguments" in window && window.arguments.length > 0)
		{
			gType = window.arguments[0][0];
			gAction = window.arguments[0][1];
			
			if(gAction == "add") {
				gTargetName = window.arguments[0][2];
			} else if(gAction == "edit") {
				gTitleTextbox.value = gEditedItem.mTitle;
				gTextTextbox.value = gEditedItem.mText;
			}
		} else {
			// XXX Localize this using stringbundles! Send message using
			//     XPCOMViewer's statusbar
			alert("No parameters sended! Closing dialog...");
			window.close();
		}
  }, // end onLoad(aEvent)


  /**
   * On dialog accept.
   */
  onAccept : function(aEvent)
  {
    if(gType == "note" && gTitleTextbox.value == "") {
      // XXX Localize this using stringbundles!
      alert("No title inserted. Canceling saving...");
      return false;
    }
    
    if(gAction == "add") 
    {
      if(gType == "note") {
        var note = new opener.SingleNoteObjectPrototype(-1, gTitleTextbox.value, 
            gTextTextbox.value, gTargetName, (new Date()).getCurrentTimestamp());
        
        opener.gNotesDb.add(note);
        opener.gNotesSrv.refreshTree();
      } 
      else /*if(gType == "bookmark")*/
      {
        var bookmark = new opener.SingleBookmarkObjectPrototype(-1, gTextTextbox.value, 
            gTargetName, (new Date()).getCurrentTimestamp());
        
        opener.gBookmarksDb.add(bookmark);
        opener.gBookmarksSrv.refreshTree();
      }
    } 
    else /*if(gAction == "edit")*/
    {
      if(gType == "note") 
      {
        var newNote = new opener.SingleNoteObjectPrototype(gEditedItem.mId, 
            gTitleTextbox.value, gTextTextbox.value, gEditedItem.mTarget, 
            (new Date()).getCurrentTimestamp());
        
        opener.gNotesDb.update(gEditedItem, newNote);
        opener.gNotesSrv.refreshTree();
      } 
      else /*if(gType == "bookmark")*/
      {
        var newBookmark = new opener.SingleBookmarkObjectPrototype(gEditedItem.mId, 
            gTextTextbox.value, gEditedItem.mTarget, (new Date()).getCurrentTimestamp());
        
        opener.gBookmarksDb.update(gEditedItem, newBookmark);
        opener.gBookmarksSrv.refreshTree();
      }
    }

    return true;
  } // end onAccept(aEvent)

}; // End of gNoteDialog
